#!/usr/bin/env python

import sys
import openpluginlib
import openimagelib
import openmedialib
import common
import stacks
import balance

def rpn( graph, store_parameters, cancel_fn, init_update_fn, update_fn ):

	#print graph
	#print store_parameters
	
	project = stacks.project( )
	rpn = stacks.stack( project )
	rpn.push_args( graph )
	input = rpn.pop( )
	if input is not None:
		balance.activate( input )

		frame = input.fetch( )
		if frame is not None:
			store = openmedialib.create_store( store_parameters[ "name" ], frame )

			for k in store_parameters.keys():
				if k == "name":
					continue
				prop = store.properties().get_property( k )
				if prop.valid():
					prop.set_from_string( store_parameters[ k ] )

			if store.init():
				i = 0
				init_update_fn( input.get_frames() )
				while i < input.get_frames( ):
					if cancel_fn():
						break
					
					if not store.push( frame ):
						break
					
					i += 1
					input.seek( i, False )
					frame = input.fetch( )

					update_fn( float( i ) )
					
		store.complete()

		balance.deactivate( input )
	else:
		print "Errors occurred with command line arguments"
